#include "defines.h"
#include "kozos.h"
#include "interrupt.h"
#include "lib.h"

/* ƥࡦȥ桼εư */
static int start_threads(int argc, char *argv[])
{
  /*
   * Drivers
   */
  kz_run(driver_console,    "dConsole",  1, 0x200, 0, NULL);
  kz_run(driver_timer,      "dTimer",    2, 0x200, 0, NULL);
  /*
   * Tasks
   */
  kz_run(task_display,      "tDisplay",  5, 0x800, 0, NULL);
  kz_run(task_audio,        "tAudio",    5, 0x800, 0, NULL);
  kz_run(task_input,        "tInput",    5, 0x800, 0, NULL);
  kz_run(task_command,      "tCommand",  8, 0x800, 0, NULL);

  kz_chpri(15); /* ̤ͥ򲼤ơɥ륹åɤ˰ܹԤ */
  INTR_ENABLE; /* ͭˤ */
  while (1) {
    asm volatile ("sleep"); /* ϥ⡼ɤ˰ܹ */
  }

  return 0;
}

int main(void)
{
  INTR_DISABLE; /* ̵ˤ */

  puts("kozos boot succeed!\n");

  /* OSư */
  kz_start(start_threads, "idle", 0, 0x100, 0, NULL);
  /* ˤäƤʤ */

  return 0;
}

